class Plugins::Sidebars::CommentsController < Sidebars::Plugin
  def self.display_name
    "Recent Comments"
  end

  def self.description
    "Links to recently-posted comments"
  end
  
  def self.default_config
    { 'count' => 10 }
  end

  def content
    # We really want to write "find(:all, :order => 'created_at DESC',
    # :limit => @sb_config['count'], :include => [:article])", but because
    # comments and articles are stored in the same table, Rails will fall
    # over and die horribly if we do that.  We could also choose to leave
    # off the :include, but then our performance would be ghastly.
    @articles = Article.find_by_sql([<<END_SQL, @sb_config['count']])
SELECT article.*, comment.author AS comment_author, comment.id AS comment_id
  FROM contents AS comment
  LEFT JOIN contents AS article ON comment.article_id = article.id
  WHERE comment.type = 'Comment' AND article.type = 'Article'
  ORDER BY comment.created_at DESC LIMIT ?
END_SQL
  end

  def configure
  end
end
